#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

typedef struct {
    long l, h;
	} int64;

// rdtsc - Read Time Stamp Counter
// The 64 bit value is written into memory pointed to by ptr.
void rdtsc64( int64 *ptr );
#pragma aux rdtsc64 = "db 0fh,31h" "mov [ebx],eax" "mov [ebx+4],edx" \
	parm nomemory [ebx] modify exact nomemory [eax edx];


// rdtsc32 - Read Time Stamp Counter 32
// Read only the least significant 32 bits of the 64 bit cycle counter
// edx contains the most significant 32 bits, but it not returned by this
// pragma.
unsigned rdtsc32( void );
#pragma aux rdtsc32 = "db 0fh,31h" \
	parm nomemory [] modify exact nomemory [eax edx];

main() {
	int64 start_time64, stop_time64;
	unsigned start_time32, stop_time32, time32;

	do {
		rdtsc64( &start_time64 );
		start_time32 = rdtsc32();
		sleep(1);
		rdtsc64( &stop_time64 );
		stop_time32 = rdtsc32();
		} while (start_time32 > stop_time32);
	time32 = stop_time32 - start_time32;

	printf( "Pentium Clock Speed Measurement:\n\n" );
	printf( "1 second took %d cycles on this machine.\n", time32 );
	printf( "This must be a %3.1f MHz Pentium.\n\n",
		(float) time32 / 1000000.0);
	printf( "Actual 64 bit cycle count values were:\n" );
	printf( "start_time: %10u:%u\n", start_time64.h, start_time64.l );
	printf( "stop_time:  %10u:%u\n", stop_time64.h, stop_time64.l );
	}
